-- FTP support
-- Daniel Berstein

include machine.e
include dll.e

global atom	wininet
global integer	InternetAttemptConnect, InternetOpen, InternetConnect, FtpSetCurrentDirectory,
	FtpGetFile, FtpPutFile, InternetCloseHandle, InternetAutodialHangup

constant HINTERNET = C_UINT
constant TRUE = 1
constant FALSE = 0

procedure not_found(sequence name)
	puts(1, "Couldn't find " & name & '\n')
	abort(1)
end procedure

function link_c_func(atom dll, sequence name, sequence args, atom result)
-- dynamically link a C routine as a Euphoria function
	integer handle
	handle = define_c_func(dll, name, args, result)
	if handle = -1 then
		not_found(name)
	else
		return handle
	end if
end function

wininet = open_dll("wininet.dll")

InternetAttemptConnect = link_c_func(wininet,
	"InternetAttemptConnect",{C_INT},C_INT)
--DWORD InternetAttemptConnect(
--    IN DWORD dwReserved
--);

InternetOpen = link_c_func(wininet,
	"InternetOpenA",{C_POINTER,C_INT,C_POINTER,C_POINTER,C_INT},HINTERNET)
--HINTERNET InternetOpen(
--    IN LPCSTR lpszAgent,
--    IN DWORD dwAccessType,
--    IN LPCSTR lpszProxyName,
--    IN LPCSTR lpszProxyBypass,
--    IN DWORD dwFlags
--);

InternetConnect = link_c_func(wininet,
	"InternetConnectA",{HINTERNET,C_POINTER,C_INT,C_POINTER,C_POINTER,C_INT,C_INT,C_INT},HINTERNET)
--HINTERNET InternetConnect(
--    IN HINTERNET hInternetSession,
--    IN LPCSTR lpszServerName,
--    IN INTERNET_PORT nServerPort,
--    IN LPCSTR lpszUsername,
--    IN LPCSTR lpszPassword,
--    IN DWORD dwService,
--    IN DWORD dwFlags,
--    IN DWORD dwContext
--);

FtpSetCurrentDirectory = link_c_func(wininet,
	"FtpSetCurrentDirectoryA",{HINTERNET,C_POINTER},C_INT)
--BOOL FtpSetCurrentDirectory(
--    IN HINTERNET hFtpSession,
--    IN LPCSTR lpszDirectory
--);

FtpGetFile = link_c_func(wininet,
	"FtpGetFileA",{HINTERNET,C_POINTER,C_POINTER,C_INT,C_INT,C_INT,C_INT},C_INT)
--BOOL FtpGetFile(
--    IN HINTERNET hFtpSession,
--    IN LPCSTR lpszRemoteFile,
--    IN LPCSTR lpszNewFile,
--    IN BOOL fFailIfExists,
--    IN DWORD dwLocalFlagsAndAttributes,
--    IN DWORD dwInternetFlags,
--    IN DWORD dwContext
--);

FtpPutFile = link_c_func(wininet,
	"FtpPutFileA",{HINTERNET,C_POINTER,C_POINTER,C_INT,C_INT},C_INT)
--BOOL FtpPutFile(
--    IN HINTERNET hFtpSession,
--    IN LPCSTR lpszLocalFile,
--    IN LPCSTR lpszNewRemoteFile,
--    IN DWORD dwFlags,
--    IN DWORD dwContext
--);

InternetCloseHandle = link_c_func(wininet,
	"InternetCloseHandle",{HINTERNET},C_INT)
--BOOL InternetCloseHandle(
--    IN HINTERNET hInet
--);

InternetAutodialHangup = link_c_func(wininet,
	"InternetAutodialHangup",{C_INT},C_INT)
--BOOL InternetAutodialHangup(
--    IN DWORD dwReserved
--);

